package internal

import "encoding/json"

type ServerConfig struct {
	Speed     float64
	UnitSpeed float64
	Moral     int
}

type NullServerConfig struct {
	Value ServerConfig
	Valid bool
}

func (s NullServerConfig) MarshalJSON() ([]byte, error) {
	if !s.Valid {
		return []byte("null"), nil
	}

	return json.Marshal(s.Value)
}

func (s *NullServerConfig) UnmarshalJSON(data []byte) error {
	// Ignore null, like in the main JSON package.
	if string(data) == "null" {
		return nil
	}

	if err := json.Unmarshal(data, &s.Value); err != nil {
		return err
	}

	s.Valid = true

	return nil

}
