-- https://docs.sqlc.dev/en/latest/reference/query-annotations.html
-- https://docs.sqlc.dev/en/latest/howto/named_parameters.html

-- https://docs.sqlc.dev/en/latest/howto/insert.html
-- name: CreateVersion :one
INSERT INTO versions (code, name, host, timezone)
VALUES ($1, $2, $3, $4)
RETURNING *;

-- https://docs.sqlc.dev/en/latest/howto/select.html
-- name: ListVersions :many
SELECT *
from versions
ORDER BY code ASC;

-- https://docs.sqlc.dev/en/latest/howto/select.html
-- name: ListVersionsWithServerCount :many
SELECT sqlc.embed(v), count_servers(v.version_code) as cnt
from versions v
ORDER BY v.code ASC;

-- https://docs.sqlc.dev/en/latest/howto/select.html
-- name: GetVersion :one
SELECT *
from versions
WHERE code = $1
LIMIT 1;
