-- +goose Up
create table if not exists servers
(
    key                         varchar(100)                                       not null
        primary key,
    url                         varchar(255)                                       not null,
    open                        boolean                  default false,
    special                     boolean                  default false,
    num_players                 bigint                   default 0,
    num_tribes                  bigint                   default 0,
    num_villages                bigint                   default 0,
    config                      jsonb,
    building_info               jsonb,
    unit_info                   jsonb,
    created_at                  timestamp with time zone default CURRENT_TIMESTAMP not null,
    player_data_updated_at      timestamp with time zone,
    tribe_data_updated_at       timestamp with time zone,
    village_data_updated_at     timestamp with time zone,
    version_code                varchar(6)                                         not null
        references versions,
    player_snapshots_created_at timestamp with time zone,
    tribe_snapshots_created_at  timestamp with time zone,
    ennoblement_data_updated_at timestamp with time zone,
    num_player_villages         bigint                   default 0,
    num_barbarian_villages      bigint                   default 0,
    num_bonus_villages          bigint                   default 0
);

-- +goose Down
drop table if exists servers cascade;
