-- +goose Up
-- +goose StatementBegin
create function count_servers(ver_code varchar)
    returns bigint
    language plpgsql
as
$$
declare
    cnt bigint;
begin
    select count(*)
    into cnt
    from servers
    where version_code = ver_code;

    return cnt;
end;
$$;

create function count_servers_by_version_code()
    returns table(version_code varchar, cnt bigint)
    language plpgsql
as
$$
begin
    return query
        SELECT server.version_code, count(server.key) cnt
        FROM servers server
        GROUP BY server.version_code
        ORDER BY server.version_code ASC;
end;
$$;
-- +goose StatementEnd

-- +goose Down
-- +goose StatementBegin
drop function count_servers(ver_code varchar);
drop function count_servers_by_version_code();
-- +goose StatementEnd
