-- +goose Up
-- +goose StatementBegin
-- VERSIONS
insert into versions (code, name, host, timezone)
values ('pl', 'Poland', 'www.plemiona.pl', 'Europe/Warsaw'),
       ('uk', 'United Kingdom', 'www.tribalwars.co.uk', 'Europe/London'),
       ('hu', 'Hungary', 'www.klanhaboru.hu', 'Europe/Budapest'),
       ('it', 'Italy', 'www.tribals.it', 'Europe/Rome'),
       ('fr', 'France', 'www.guerretribale.fr', 'Europe/Paris'),
       ('us', 'United States', 'www.tribalwars.us', 'America/New_York'),
       ('nl', 'The Netherlands', 'www.tribalwars.nl', 'Europe/Amsterdam'),
       ('es', 'Spain', 'www.guerrastribales.es', 'Europe/Madrid'),
       ('ro', 'Romania', 'www.triburile.ro', 'Europe/Bucharest'),
       ('gr', 'Greece', 'www.fyletikesmaxes.gr', 'Europe/Athens'),
       ('br', 'Brazil', 'www.tribalwars.com.br', 'America/Sao_Paulo'),
       ('tr', 'Turkey', 'www.klanlar.org', 'Europe/Istanbul'),
       ('cs', 'Czech Republic', 'www.divokekmeny.cz', 'Europe/Prague'),
       ('ch', 'Switzerland', 'www.staemme.ch', 'Europe/Zurich'),
       ('pt', 'Portugal', 'www.tribalwars.com.pt', 'Europe/Lisbon'),
       ('en', 'International', 'www.tribalwars.net', 'Europe/London'),
       ('de', 'Germany', 'www.die-staemme.de', 'Europe/Berlin'),
       ('sk', 'Slovakia', 'www.divoke-kmene.sk', 'Europe/Bratislava'),
       ('ru', 'Russia', 'www.voynaplemyon.com', 'Europe/Moscow');

-- SERVERS
insert into servers (key, url, open, special, num_players, num_tribes, num_villages, config, building_info, unit_info, created_at, player_data_updated_at, tribe_data_updated_at, village_data_updated_at, version_code, player_snapshots_created_at, tribe_snapshots_created_at, ennoblement_data_updated_at, num_player_villages, num_barbarian_villages, num_bonus_villages)
values  ('uk69', 'https://uk69.tribalwars.co.uk', true, false, 1371, 98, 4645, '{"Win": {"Check": 3}, "Ally": {"Limit": 20, "Levels": 1, "NoHarm": 1, "NoJoin": 0, "NoLeave": 0, "FixedAllies": 0, "NoOtherSupport": 2, "XpRequirements": "v1", "AllytimeSupport": 3, "PointsMemberCount": 0, "NoOtherSupportType": 1, "WarsAutoacceptDays": 7, "WarsMemberRequirement": 5, "WarsPointsRequirement": 15000}, "Game": {"Tech": 2, "Event": 31, "Hauls": 1, "Archer": 1, "Church": 0, "Knight": 3, "HaulsMax": 100000, "FakeLimit": 0, "FarmLimit": 0, "HaulsBase": 1000, "Scavenging": 1, "Stronghold": 0, "Watchtower": 1, "BarbarianRise": 0.003, "BaseProduction": 30, "KnightNewItems": 0, "SuppressEvents": 0, "BarbarianShrink": 1, "BuildtimeFormula": 2, "BarbarianMaxPoints": 1800}, "Misc": {"Tutorial": 5, "KillRanking": 2, "TradeCancelTime": 300}, "Snob": {"Gold": 1, "Rise": 2, "Factor": 1, "MaxDist": 50, "CoinIron": 25000, "CoinWood": 28000, "CoinStone": 30000, "CheapRebuild": 0, "NoBarbConquer": 0}, "Build": {"Destroy": 1}, "Coord": {"Func": 4, "Inner": 1208, "MapSize": 1000, "BonusNew": 0, "SelectStart": 1, "NobleRestart": 1, "BonusVillages": 10, "EmptyVillages": 50, "StartVillages": 1, "VillageMoveWait": 336}, "Moral": 1, "Night": {"Active": 1, "EndHour": 8, "Duration": 14, "DefFactor": 3, "StartHour": 24}, "Sleep": {"Max": 10, "Min": 6, "Delay": 60, "Active": 0, "MaxAwake": 36, "MinAwake": 12, "WarnTime": 10}, "Speed": 2, "Newbie": {"Days": 4, "Ratio": 20, "RatioDays": 45, "RemoveNewbieVillages": 1}, "Sitter": {"Allow": 1}, "Commands": {"MillisArrival": 1, "CommandCancelTime": 600}, "Buildings": {"CustomFarm": -1, "CustomHide": -1, "CustomIron": -1, "CustomMain": -1, "CustomSnob": -1, "CustomWall": -1, "CustomWood": -1, "CustomPlace": -1, "CustomSmith": -1, "CustomStone": -1, "CustomChurch": -1, "CustomGarage": -1, "CustomMarket": -1, "CustomStable": -1, "CustomStatue": -1, "CustomStorage": -1, "CustomBarracks": -1, "CustomWatchtower": -1}, "UnitSpeed": 0.75}', '{"Farm": {"Pop": 0, "Iron": 30, "Wood": 45, "Stone": 40, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 600, "PopFactor": 1, "IronFactor": 1.29, "WoodFactor": 1.3, "StoneFactor": 1.32, "BuildTimeFactor": 1.2}, "Hide": {"Pop": 2, "Iron": 50, "Wood": 50, "Stone": 60, "MaxLevel": 10, "MinLevel": 0, "BuildTime": 900, "PopFactor": 1.17, "IronFactor": 1.25, "WoodFactor": 1.25, "StoneFactor": 1.25, "BuildTimeFactor": 1.2}, "Iron": {"Pop": 10, "Iron": 70, "Wood": 75, "Stone": 65, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 540, "PopFactor": 1.17, "IronFactor": 1.24, "WoodFactor": 1.252, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Main": {"Pop": 5, "Iron": 70, "Wood": 90, "Stone": 80, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 450, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Snob": {"Pop": 80, "Iron": 10000, "Wood": 15000, "Stone": 25000, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 293400, "PopFactor": 1.17, "IronFactor": 2, "WoodFactor": 2, "StoneFactor": 2, "BuildTimeFactor": 1.2}, "Wall": {"Pop": 5, "Iron": 20, "Wood": 50, "Stone": 100, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 1800, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Wood": {"Pop": 5, "Iron": 40, "Wood": 50, "Stone": 60, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 450, "PopFactor": 1.155, "IronFactor": 1.245, "WoodFactor": 1.25, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Place": {"Pop": 0, "Iron": 30, "Wood": 10, "Stone": 40, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 5430, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Smith": {"Pop": 20, "Iron": 240, "Wood": 220, "Stone": 180, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 3000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stone": {"Pop": 10, "Iron": 40, "Wood": 65, "Stone": 50, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 450, "PopFactor": 1.14, "IronFactor": 1.24, "WoodFactor": 1.27, "StoneFactor": 1.265, "BuildTimeFactor": 1.2}, "Garage": {"Pop": 8, "Iron": 260, "Wood": 300, "Stone": 240, "MaxLevel": 15, "MinLevel": 0, "BuildTime": 3000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Market": {"Pop": 20, "Iron": 100, "Wood": 100, "Stone": 100, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 1350, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stable": {"Pop": 8, "Iron": 260, "Wood": 270, "Stone": 240, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 3000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Statue": {"Pop": 10, "Iron": 220, "Wood": 220, "Stone": 220, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 750, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Storage": {"Pop": 0, "Iron": 40, "Wood": 60, "Stone": 50, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 510, "PopFactor": 1.15, "IronFactor": 1.245, "WoodFactor": 1.265, "StoneFactor": 1.27, "BuildTimeFactor": 1.2}, "Barracks": {"Pop": 7, "Iron": 90, "Wood": 200, "Stone": 170, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 900, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Watchtower": {"Pop": 500, "Iron": 10000, "Wood": 12000, "Stone": 14000, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 6600, "PopFactor": 1.18, "IronFactor": 1.18, "WoodFactor": 1.17, "StoneFactor": 1.17, "BuildTimeFactor": 1.2}}', '{"Axe": {"Pop": 1, "Carry": 10, "Speed": 12, "Attack": 40, "Defense": 10, "BuildTime": 660, "DefenseArcher": 10, "DefenseCavalry": 5}, "Ram": {"Pop": 5, "Carry": 0, "Speed": 20, "Attack": 2, "Defense": 20, "BuildTime": 2400, "DefenseArcher": 20, "DefenseCavalry": 50}, "Spy": {"Pop": 2, "Carry": 0, "Speed": 6, "Attack": 0, "Defense": 2, "BuildTime": 450, "DefenseArcher": 2, "DefenseCavalry": 1}, "Snob": {"Pop": 100, "Carry": 0, "Speed": 23.333333333333, "Attack": 30, "Defense": 100, "BuildTime": 9000, "DefenseArcher": 100, "DefenseCavalry": 50}, "Heavy": {"Pop": 6, "Carry": 50, "Speed": 7.3333333333333, "Attack": 150, "Defense": 200, "BuildTime": 1800, "DefenseArcher": 180, "DefenseCavalry": 80}, "Light": {"Pop": 4, "Carry": 80, "Speed": 6.6666666666667, "Attack": 130, "Defense": 30, "BuildTime": 900, "DefenseArcher": 30, "DefenseCavalry": 40}, "Spear": {"Pop": 1, "Carry": 25, "Speed": 12, "Attack": 10, "Defense": 15, "BuildTime": 510, "DefenseArcher": 20, "DefenseCavalry": 45}, "Sword": {"Pop": 1, "Carry": 15, "Speed": 14.666666666667, "Attack": 25, "Defense": 50, "BuildTime": 750, "DefenseArcher": 40, "DefenseCavalry": 15}, "Archer": {"Pop": 1, "Carry": 10, "Speed": 12, "Attack": 15, "Defense": 50, "BuildTime": 900, "DefenseArcher": 5, "DefenseCavalry": 40}, "Knight": {"Pop": 10, "Carry": 100, "Speed": 6.6666666666667, "Attack": 150, "Defense": 250, "BuildTime": 10800, "DefenseArcher": 150, "DefenseCavalry": 400}, "Marcher": {"Pop": 5, "Carry": 50, "Speed": 6.6666666666667, "Attack": 120, "Defense": 40, "BuildTime": 1350, "DefenseArcher": 50, "DefenseCavalry": 30}, "Militia": {"Pop": 0, "Carry": 0, "Speed": 0.016666666666667, "Attack": 0, "Defense": 15, "BuildTime": 1, "DefenseArcher": 25, "DefenseCavalry": 45}, "Catapult": {"Pop": 8, "Carry": 0, "Speed": 20, "Attack": 100, "Defense": 100, "BuildTime": 3600, "DefenseArcher": 100, "DefenseCavalry": 50}}', '2023-06-22 19:00:05.827934 +00:00', '2023-08-13 05:01:45.237565 +00:00', '2023-08-13 05:00:35.971424 +00:00', '2023-08-13 05:03:11.613044 +00:00', 'uk', '2023-08-12 23:30:14.608491 +00:00', '2023-08-12 23:30:03.401455 +00:00', '2023-08-13 05:21:11.551129 +00:00', 3235, 1410, 290),
        ('it79', 'https://it79.tribals.it', true, false, 1048, 74, 3302, '{"Win": {"Check": 5}, "Ally": {"Limit": 10, "Levels": 1, "NoHarm": 0, "NoJoin": 0, "NoLeave": 0, "FixedAllies": 0, "NoOtherSupport": 2, "XpRequirements": "v1", "AllytimeSupport": 0, "PointsMemberCount": 0, "NoOtherSupportType": 0, "WarsAutoacceptDays": 7, "WarsMemberRequirement": 5, "WarsPointsRequirement": 15000}, "Game": {"Tech": 2, "Event": 0, "Hauls": 1, "Archer": 0, "Church": 0, "Knight": 0, "HaulsMax": 100000, "FakeLimit": 1, "FarmLimit": 1500, "HaulsBase": 1000, "Scavenging": 1, "Stronghold": 0, "Watchtower": 1, "BarbarianRise": 0.003, "BaseProduction": 30, "KnightNewItems": 0, "SuppressEvents": 0, "BarbarianShrink": 0, "BuildtimeFormula": 2, "BarbarianMaxPoints": 1500}, "Misc": {"Tutorial": 5, "KillRanking": 2, "TradeCancelTime": 300}, "Snob": {"Gold": 1, "Rise": 2, "Factor": 1, "MaxDist": 2000, "CoinIron": 25000, "CoinWood": 28000, "CoinStone": 30000, "CheapRebuild": 0, "NoBarbConquer": 0}, "Build": {"Destroy": 1}, "Coord": {"Func": 4, "Inner": 832, "MapSize": 1000, "BonusNew": 0, "SelectStart": 0, "NobleRestart": 1, "BonusVillages": 50, "EmptyVillages": 50, "StartVillages": 2, "VillageMoveWait": -1}, "Moral": 3, "Night": {"Active": 2, "EndHour": 7, "Duration": 14, "DefFactor": 3, "StartHour": 23}, "Sleep": {"Max": 10, "Min": 6, "Delay": 60, "Active": 0, "MaxAwake": 36, "MinAwake": 12, "WarnTime": 10}, "Speed": 3, "Newbie": {"Days": 2, "Ratio": 30, "RatioDays": 10, "RemoveNewbieVillages": 1}, "Sitter": {"Allow": 1}, "Commands": {"MillisArrival": 1, "CommandCancelTime": 600}, "Buildings": {"CustomFarm": -1, "CustomHide": -1, "CustomIron": -1, "CustomMain": -1, "CustomSnob": -1, "CustomWall": -1, "CustomWood": -1, "CustomPlace": -1, "CustomSmith": -1, "CustomStone": -1, "CustomChurch": -1, "CustomGarage": -1, "CustomMarket": -1, "CustomStable": -1, "CustomStatue": -1, "CustomStorage": -1, "CustomBarracks": -1, "CustomWatchtower": -1}, "UnitSpeed": 0.6}', '{"Farm": {"Pop": 0, "Iron": 30, "Wood": 45, "Stone": 40, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 400, "PopFactor": 1, "IronFactor": 1.29, "WoodFactor": 1.3, "StoneFactor": 1.32, "BuildTimeFactor": 1.2}, "Hide": {"Pop": 2, "Iron": 50, "Wood": 50, "Stone": 60, "MaxLevel": 10, "MinLevel": 0, "BuildTime": 600, "PopFactor": 1.17, "IronFactor": 1.25, "WoodFactor": 1.25, "StoneFactor": 1.25, "BuildTimeFactor": 1.2}, "Iron": {"Pop": 10, "Iron": 70, "Wood": 75, "Stone": 65, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 360, "PopFactor": 1.17, "IronFactor": 1.24, "WoodFactor": 1.252, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Main": {"Pop": 5, "Iron": 70, "Wood": 90, "Stone": 80, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 300, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Snob": {"Pop": 80, "Iron": 10000, "Wood": 15000, "Stone": 25000, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 195600, "PopFactor": 1.17, "IronFactor": 2, "WoodFactor": 2, "StoneFactor": 2, "BuildTimeFactor": 1.2}, "Wall": {"Pop": 5, "Iron": 20, "Wood": 50, "Stone": 100, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 1200, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Wood": {"Pop": 5, "Iron": 40, "Wood": 50, "Stone": 60, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 300, "PopFactor": 1.155, "IronFactor": 1.245, "WoodFactor": 1.25, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Place": {"Pop": 0, "Iron": 30, "Wood": 10, "Stone": 40, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 3620, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Smith": {"Pop": 20, "Iron": 240, "Wood": 220, "Stone": 180, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 2000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stone": {"Pop": 10, "Iron": 40, "Wood": 65, "Stone": 50, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 300, "PopFactor": 1.14, "IronFactor": 1.24, "WoodFactor": 1.27, "StoneFactor": 1.265, "BuildTimeFactor": 1.2}, "Garage": {"Pop": 8, "Iron": 260, "Wood": 300, "Stone": 240, "MaxLevel": 15, "MinLevel": 0, "BuildTime": 2000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Market": {"Pop": 20, "Iron": 100, "Wood": 100, "Stone": 100, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 900, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stable": {"Pop": 8, "Iron": 260, "Wood": 270, "Stone": 240, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 2000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Statue": {"Pop": 0, "Iron": 0, "Wood": 0, "Stone": 0, "MaxLevel": 0, "MinLevel": 0, "BuildTime": 0, "PopFactor": 0, "IronFactor": 0, "WoodFactor": 0, "StoneFactor": 0, "BuildTimeFactor": 0}, "Storage": {"Pop": 0, "Iron": 40, "Wood": 60, "Stone": 50, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 340, "PopFactor": 1.15, "IronFactor": 1.245, "WoodFactor": 1.265, "StoneFactor": 1.27, "BuildTimeFactor": 1.2}, "Barracks": {"Pop": 7, "Iron": 90, "Wood": 200, "Stone": 170, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 600, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Watchtower": {"Pop": 500, "Iron": 10000, "Wood": 12000, "Stone": 14000, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 4400, "PopFactor": 1.18, "IronFactor": 1.18, "WoodFactor": 1.17, "StoneFactor": 1.17, "BuildTimeFactor": 1.2}}', '{"Axe": {"Pop": 1, "Carry": 10, "Speed": 10, "Attack": 40, "Defense": 10, "BuildTime": 440, "DefenseArcher": 10, "DefenseCavalry": 5}, "Ram": {"Pop": 5, "Carry": 0, "Speed": 16.666666666667, "Attack": 2, "Defense": 20, "BuildTime": 1600, "DefenseArcher": 20, "DefenseCavalry": 50}, "Spy": {"Pop": 2, "Carry": 0, "Speed": 5, "Attack": 0, "Defense": 2, "BuildTime": 300, "DefenseArcher": 2, "DefenseCavalry": 1}, "Snob": {"Pop": 100, "Carry": 0, "Speed": 19.444444444444, "Attack": 30, "Defense": 100, "BuildTime": 6000, "DefenseArcher": 100, "DefenseCavalry": 50}, "Heavy": {"Pop": 6, "Carry": 50, "Speed": 6.1111111111111, "Attack": 150, "Defense": 200, "BuildTime": 1200, "DefenseArcher": 180, "DefenseCavalry": 80}, "Light": {"Pop": 4, "Carry": 80, "Speed": 5.5555555555556, "Attack": 130, "Defense": 30, "BuildTime": 600, "DefenseArcher": 30, "DefenseCavalry": 40}, "Spear": {"Pop": 1, "Carry": 25, "Speed": 10, "Attack": 10, "Defense": 15, "BuildTime": 340, "DefenseArcher": 20, "DefenseCavalry": 45}, "Sword": {"Pop": 1, "Carry": 15, "Speed": 12.222222222222, "Attack": 25, "Defense": 50, "BuildTime": 500, "DefenseArcher": 40, "DefenseCavalry": 25}, "Archer": {"Pop": 0, "Carry": 0, "Speed": 0, "Attack": 0, "Defense": 0, "BuildTime": 0, "DefenseArcher": 0, "DefenseCavalry": 0}, "Knight": {"Pop": 0, "Carry": 0, "Speed": 0, "Attack": 0, "Defense": 0, "BuildTime": 0, "DefenseArcher": 0, "DefenseCavalry": 0}, "Marcher": {"Pop": 0, "Carry": 0, "Speed": 0, "Attack": 0, "Defense": 0, "BuildTime": 0, "DefenseArcher": 0, "DefenseCavalry": 0}, "Militia": {"Pop": 0, "Carry": 0, "Speed": 0, "Attack": 0, "Defense": 0, "BuildTime": 0, "DefenseArcher": 0, "DefenseCavalry": 0}, "Catapult": {"Pop": 8, "Carry": 0, "Speed": 16.666666666667, "Attack": 100, "Defense": 100, "BuildTime": 2400, "DefenseArcher": 100, "DefenseCavalry": 50}}', '2023-07-28 16:00:03.397203 +00:00', '2023-08-13 05:01:03.074593 +00:00', '2023-08-13 05:00:24.544991 +00:00', '2023-08-13 05:01:52.853333 +00:00', 'it', '2023-08-12 22:30:25.993302 +00:00', '2023-08-12 22:30:04.417865 +00:00', '2023-08-13 05:21:09.608167 +00:00', 2119, 1183, 581),
        ('fr80', 'https://fr80.guerretribale.fr', true, false, 388, 47, 3826, '{"Win": {"Check": 3}, "Ally": {"Limit": 15, "Levels": 1, "NoHarm": 1, "NoJoin": 0, "NoLeave": 0, "FixedAllies": 0, "NoOtherSupport": 2, "XpRequirements": "v1", "AllytimeSupport": 2, "PointsMemberCount": 0, "NoOtherSupportType": 0, "WarsAutoacceptDays": 7, "WarsMemberRequirement": 5, "WarsPointsRequirement": 15000}, "Game": {"Tech": 2, "Event": 0, "Hauls": 0, "Archer": 1, "Church": 0, "Knight": 1, "HaulsMax": 100000, "FakeLimit": 0.5, "FarmLimit": 0, "HaulsBase": 1000, "Scavenging": 0, "Stronghold": 0, "Watchtower": 0, "BarbarianRise": 0.003, "BaseProduction": 75, "KnightNewItems": 0, "SuppressEvents": 1, "BarbarianShrink": 0, "BuildtimeFormula": 2, "BarbarianMaxPoints": 1500}, "Misc": {"Tutorial": 0, "KillRanking": 2, "TradeCancelTime": 300}, "Snob": {"Gold": 1, "Rise": 2, "Factor": 1, "MaxDist": 20, "CoinIron": 25000, "CoinWood": 28000, "CoinStone": 30000, "CheapRebuild": 0, "NoBarbConquer": 0}, "Build": {"Destroy": 1}, "Coord": {"Func": 4, "Inner": 1674, "MapSize": 1000, "BonusNew": 0, "SelectStart": 0, "NobleRestart": 1, "BonusVillages": 40, "EmptyVillages": 40, "StartVillages": 1, "VillageMoveWait": 336}, "Moral": 3, "Night": {"Active": 1, "EndHour": 8, "Duration": 14, "DefFactor": 3, "StartHour": 0}, "Sleep": {"Max": 10, "Min": 6, "Delay": 60, "Active": 0, "MaxAwake": 36, "MinAwake": 12, "WarnTime": 10}, "Speed": 1, "Newbie": {"Days": 5, "Ratio": 20, "RatioDays": 30, "RemoveNewbieVillages": 1}, "Sitter": {"Allow": 1}, "Commands": {"MillisArrival": 1, "CommandCancelTime": 600}, "Buildings": {"CustomFarm": -1, "CustomHide": -1, "CustomIron": -1, "CustomMain": -1, "CustomSnob": -1, "CustomWall": -1, "CustomWood": -1, "CustomPlace": -1, "CustomSmith": -1, "CustomStone": -1, "CustomChurch": -1, "CustomGarage": -1, "CustomMarket": -1, "CustomStable": -1, "CustomStatue": -1, "CustomStorage": -1, "CustomBarracks": -1, "CustomWatchtower": -1}, "UnitSpeed": 1}', '{"Farm": {"Pop": 0, "Iron": 30, "Wood": 45, "Stone": 40, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 1200, "PopFactor": 1, "IronFactor": 1.29, "WoodFactor": 1.3, "StoneFactor": 1.32, "BuildTimeFactor": 1.2}, "Hide": {"Pop": 0, "Iron": 0, "Wood": 0, "Stone": 0, "MaxLevel": 0, "MinLevel": 0, "BuildTime": 0, "PopFactor": 0, "IronFactor": 0, "WoodFactor": 0, "StoneFactor": 0, "BuildTimeFactor": 0}, "Iron": {"Pop": 10, "Iron": 70, "Wood": 75, "Stone": 65, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 1080, "PopFactor": 1.17, "IronFactor": 1.24, "WoodFactor": 1.252, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Main": {"Pop": 5, "Iron": 70, "Wood": 90, "Stone": 80, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 900, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Snob": {"Pop": 80, "Iron": 10000, "Wood": 15000, "Stone": 25000, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 586800, "PopFactor": 1.17, "IronFactor": 2, "WoodFactor": 2, "StoneFactor": 2, "BuildTimeFactor": 1.2}, "Wall": {"Pop": 5, "Iron": 20, "Wood": 50, "Stone": 100, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 3600, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Wood": {"Pop": 5, "Iron": 40, "Wood": 50, "Stone": 60, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 900, "PopFactor": 1.155, "IronFactor": 1.245, "WoodFactor": 1.25, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Place": {"Pop": 0, "Iron": 30, "Wood": 10, "Stone": 40, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 10860, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Smith": {"Pop": 20, "Iron": 240, "Wood": 220, "Stone": 180, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 6000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stone": {"Pop": 10, "Iron": 40, "Wood": 65, "Stone": 50, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 900, "PopFactor": 1.14, "IronFactor": 1.24, "WoodFactor": 1.27, "StoneFactor": 1.265, "BuildTimeFactor": 1.2}, "Garage": {"Pop": 8, "Iron": 260, "Wood": 300, "Stone": 240, "MaxLevel": 15, "MinLevel": 0, "BuildTime": 6000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Market": {"Pop": 20, "Iron": 100, "Wood": 100, "Stone": 100, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 2700, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stable": {"Pop": 8, "Iron": 260, "Wood": 270, "Stone": 240, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 6000, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Statue": {"Pop": 10, "Iron": 220, "Wood": 220, "Stone": 220, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 1500, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Storage": {"Pop": 0, "Iron": 40, "Wood": 60, "Stone": 50, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 1020, "PopFactor": 1.15, "IronFactor": 1.245, "WoodFactor": 1.265, "StoneFactor": 1.27, "BuildTimeFactor": 1.2}, "Barracks": {"Pop": 7, "Iron": 90, "Wood": 200, "Stone": 170, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 1800, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Watchtower": {"Pop": 0, "Iron": 0, "Wood": 0, "Stone": 0, "MaxLevel": 0, "MinLevel": 0, "BuildTime": 0, "PopFactor": 0, "IronFactor": 0, "WoodFactor": 0, "StoneFactor": 0, "BuildTimeFactor": 0}}', '{"Axe": {"Pop": 1, "Carry": 10, "Speed": 18, "Attack": 40, "Defense": 10, "BuildTime": 1320, "DefenseArcher": 10, "DefenseCavalry": 5}, "Ram": {"Pop": 5, "Carry": 0, "Speed": 30, "Attack": 2, "Defense": 20, "BuildTime": 4800, "DefenseArcher": 20, "DefenseCavalry": 50}, "Spy": {"Pop": 2, "Carry": 0, "Speed": 9, "Attack": 0, "Defense": 2, "BuildTime": 900, "DefenseArcher": 2, "DefenseCavalry": 1}, "Snob": {"Pop": 100, "Carry": 0, "Speed": 35, "Attack": 30, "Defense": 100, "BuildTime": 18000, "DefenseArcher": 100, "DefenseCavalry": 50}, "Heavy": {"Pop": 6, "Carry": 50, "Speed": 11, "Attack": 150, "Defense": 200, "BuildTime": 3600, "DefenseArcher": 180, "DefenseCavalry": 80}, "Light": {"Pop": 4, "Carry": 80, "Speed": 10, "Attack": 130, "Defense": 30, "BuildTime": 1800, "DefenseArcher": 30, "DefenseCavalry": 40}, "Spear": {"Pop": 1, "Carry": 25, "Speed": 18, "Attack": 10, "Defense": 15, "BuildTime": 1020, "DefenseArcher": 20, "DefenseCavalry": 45}, "Sword": {"Pop": 1, "Carry": 15, "Speed": 22, "Attack": 25, "Defense": 50, "BuildTime": 1500, "DefenseArcher": 40, "DefenseCavalry": 15}, "Archer": {"Pop": 1, "Carry": 10, "Speed": 18, "Attack": 15, "Defense": 50, "BuildTime": 1800, "DefenseArcher": 5, "DefenseCavalry": 40}, "Knight": {"Pop": 10, "Carry": 100, "Speed": 10, "Attack": 150, "Defense": 250, "BuildTime": 21600, "DefenseArcher": 150, "DefenseCavalry": 400}, "Marcher": {"Pop": 5, "Carry": 50, "Speed": 10, "Attack": 120, "Defense": 40, "BuildTime": 2700, "DefenseArcher": 50, "DefenseCavalry": 30}, "Militia": {"Pop": 0, "Carry": 0, "Speed": 0, "Attack": 0, "Defense": 0, "BuildTime": 0, "DefenseArcher": 0, "DefenseCavalry": 0}, "Catapult": {"Pop": 8, "Carry": 0, "Speed": 30, "Attack": 100, "Defense": 100, "BuildTime": 7200, "DefenseArcher": 100, "DefenseCavalry": 50}}', '2023-04-28 11:00:03.669690 +00:00', '2023-08-13 05:00:54.286798 +00:00', '2023-08-13 05:00:20.579384 +00:00', '2023-08-13 05:01:36.427002 +00:00', 'fr', '2023-08-12 22:30:22.025551 +00:00', '2023-08-12 22:30:04.020847 +00:00', '2023-08-13 05:21:08.511357 +00:00', 3413, 413, 911),
        ('hu77', 'https://hu77.klanhaboru.hu', false, false, 368, 55, 15614, '{"Win": {"Check": 3}, "Ally": {"Limit": 40, "Levels": 1, "NoHarm": 0, "NoJoin": 1, "NoLeave": 1, "FixedAllies": 0, "NoOtherSupport": 0, "XpRequirements": "v1", "AllytimeSupport": 0, "PointsMemberCount": 0, "NoOtherSupportType": 0, "WarsAutoacceptDays": 7, "WarsMemberRequirement": 5, "WarsPointsRequirement": 15000}, "Game": {"Tech": 0, "Event": 31, "Hauls": 1, "Archer": 1, "Church": 0, "Knight": 3, "HaulsMax": 100000, "FakeLimit": 1, "FarmLimit": 0, "HaulsBase": 1000, "Scavenging": 1, "Stronghold": 1, "Watchtower": 1, "BarbarianRise": 0.003, "BaseProduction": 30, "KnightNewItems": 0, "SuppressEvents": 0, "BarbarianShrink": 0, "BuildtimeFormula": 2, "BarbarianMaxPoints": 3000}, "Misc": {"Tutorial": 5, "KillRanking": 2, "TradeCancelTime": 300}, "Snob": {"Gold": 1, "Rise": 2, "Factor": 0.5, "MaxDist": 100, "CoinIron": 25000, "CoinWood": 28000, "CoinStone": 30000, "CheapRebuild": 0, "NoBarbConquer": 0}, "Build": {"Destroy": 1}, "Coord": {"Func": 4, "Inner": 2695, "MapSize": 1000, "BonusNew": 0, "SelectStart": 1, "NobleRestart": 0, "BonusVillages": 50, "EmptyVillages": 100, "StartVillages": 1, "VillageMoveWait": -1}, "Moral": 0, "Night": {"Active": 1, "EndHour": 8, "Duration": 14, "DefFactor": 2, "StartHour": 22}, "Sleep": {"Max": 10, "Min": 6, "Delay": 60, "Active": 0, "MaxAwake": 36, "MinAwake": 12, "WarnTime": 10}, "Speed": 1.25, "Newbie": {"Days": 6, "Ratio": 20, "RatioDays": 60, "RemoveNewbieVillages": 1}, "Sitter": {"Allow": 1}, "Commands": {"MillisArrival": 1, "CommandCancelTime": 600}, "Buildings": {"CustomFarm": -1, "CustomHide": -1, "CustomIron": -1, "CustomMain": -1, "CustomSnob": -1, "CustomWall": -1, "CustomWood": -1, "CustomPlace": -1, "CustomSmith": -1, "CustomStone": -1, "CustomChurch": -1, "CustomGarage": -1, "CustomMarket": -1, "CustomStable": -1, "CustomStatue": -1, "CustomStorage": -1, "CustomBarracks": -1, "CustomWatchtower": -1}, "UnitSpeed": 0.8}', '{"Farm": {"Pop": 0, "Iron": 30, "Wood": 45, "Stone": 40, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 960, "PopFactor": 1, "IronFactor": 1.29, "WoodFactor": 1.3, "StoneFactor": 1.32, "BuildTimeFactor": 1.2}, "Hide": {"Pop": 2, "Iron": 50, "Wood": 50, "Stone": 60, "MaxLevel": 10, "MinLevel": 0, "BuildTime": 1440, "PopFactor": 1.17, "IronFactor": 1.25, "WoodFactor": 1.25, "StoneFactor": 1.25, "BuildTimeFactor": 1.2}, "Iron": {"Pop": 10, "Iron": 70, "Wood": 75, "Stone": 65, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 864, "PopFactor": 1.17, "IronFactor": 1.24, "WoodFactor": 1.252, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Main": {"Pop": 5, "Iron": 70, "Wood": 90, "Stone": 80, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 720, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Snob": {"Pop": 80, "Iron": 10000, "Wood": 15000, "Stone": 25000, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 469440, "PopFactor": 1.17, "IronFactor": 2, "WoodFactor": 2, "StoneFactor": 2, "BuildTimeFactor": 1.2}, "Wall": {"Pop": 5, "Iron": 20, "Wood": 50, "Stone": 100, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 2880, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Wood": {"Pop": 5, "Iron": 40, "Wood": 50, "Stone": 60, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 720, "PopFactor": 1.155, "IronFactor": 1.245, "WoodFactor": 1.25, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Place": {"Pop": 0, "Iron": 30, "Wood": 10, "Stone": 40, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 8688, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Smith": {"Pop": 20, "Iron": 240, "Wood": 220, "Stone": 180, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 4800, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stone": {"Pop": 10, "Iron": 40, "Wood": 65, "Stone": 50, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 720, "PopFactor": 1.14, "IronFactor": 1.24, "WoodFactor": 1.27, "StoneFactor": 1.265, "BuildTimeFactor": 1.2}, "Garage": {"Pop": 8, "Iron": 260, "Wood": 300, "Stone": 240, "MaxLevel": 15, "MinLevel": 0, "BuildTime": 4800, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Market": {"Pop": 20, "Iron": 100, "Wood": 100, "Stone": 100, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 2160, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stable": {"Pop": 8, "Iron": 260, "Wood": 270, "Stone": 240, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 4800, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Statue": {"Pop": 10, "Iron": 220, "Wood": 220, "Stone": 220, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 1200, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Storage": {"Pop": 0, "Iron": 40, "Wood": 60, "Stone": 50, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 816, "PopFactor": 1.15, "IronFactor": 1.245, "WoodFactor": 1.265, "StoneFactor": 1.27, "BuildTimeFactor": 1.2}, "Barracks": {"Pop": 7, "Iron": 90, "Wood": 200, "Stone": 170, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 1440, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Watchtower": {"Pop": 500, "Iron": 10000, "Wood": 12000, "Stone": 14000, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 10560, "PopFactor": 1.18, "IronFactor": 1.18, "WoodFactor": 1.17, "StoneFactor": 1.17, "BuildTimeFactor": 1.2}}', '{"Axe": {"Pop": 1, "Carry": 10, "Speed": 18, "Attack": 40, "Defense": 10, "BuildTime": 1056, "DefenseArcher": 10, "DefenseCavalry": 5}, "Ram": {"Pop": 5, "Carry": 0, "Speed": 30, "Attack": 2, "Defense": 20, "BuildTime": 3840, "DefenseArcher": 20, "DefenseCavalry": 50}, "Spy": {"Pop": 2, "Carry": 0, "Speed": 9, "Attack": 0, "Defense": 2, "BuildTime": 720, "DefenseArcher": 2, "DefenseCavalry": 1}, "Snob": {"Pop": 100, "Carry": 0, "Speed": 35, "Attack": 30, "Defense": 100, "BuildTime": 14400, "DefenseArcher": 100, "DefenseCavalry": 50}, "Heavy": {"Pop": 6, "Carry": 50, "Speed": 11, "Attack": 150, "Defense": 200, "BuildTime": 2880, "DefenseArcher": 180, "DefenseCavalry": 80}, "Light": {"Pop": 4, "Carry": 80, "Speed": 10, "Attack": 130, "Defense": 30, "BuildTime": 1440, "DefenseArcher": 30, "DefenseCavalry": 40}, "Spear": {"Pop": 1, "Carry": 25, "Speed": 18, "Attack": 10, "Defense": 15, "BuildTime": 816, "DefenseArcher": 20, "DefenseCavalry": 45}, "Sword": {"Pop": 1, "Carry": 15, "Speed": 22, "Attack": 25, "Defense": 50, "BuildTime": 1200, "DefenseArcher": 40, "DefenseCavalry": 15}, "Archer": {"Pop": 1, "Carry": 10, "Speed": 18, "Attack": 15, "Defense": 50, "BuildTime": 1440, "DefenseArcher": 5, "DefenseCavalry": 40}, "Knight": {"Pop": 10, "Carry": 100, "Speed": 10, "Attack": 150, "Defense": 250, "BuildTime": 17280, "DefenseArcher": 150, "DefenseCavalry": 400}, "Marcher": {"Pop": 5, "Carry": 50, "Speed": 10, "Attack": 120, "Defense": 40, "BuildTime": 2160, "DefenseArcher": 50, "DefenseCavalry": 30}, "Militia": {"Pop": 0, "Carry": 0, "Speed": 0, "Attack": 0, "Defense": 0, "BuildTime": 0, "DefenseArcher": 0, "DefenseCavalry": 0}, "Catapult": {"Pop": 8, "Carry": 0, "Speed": 30, "Attack": 100, "Defense": 100, "BuildTime": 5760, "DefenseArcher": 100, "DefenseCavalry": 50}}', '2023-01-03 22:00:04.570982 +00:00', '2023-08-07 17:01:02.297242 +00:00', '2023-08-07 17:00:23.480249 +00:00', '2023-08-07 17:01:50.484109 +00:00', 'hu', '2023-08-06 22:30:23.757488 +00:00', '2023-08-06 22:30:04.264837 +00:00', '2023-08-07 18:00:06.467568 +00:00', 12848, 2766, 3210),
        ('uk66', 'https://uk66.tribalwars.co.uk', false, false, 183, 51, 9195, '{"Win": {"Check": 3}, "Ally": {"Limit": 20, "Levels": 1, "NoHarm": 1, "NoJoin": 1, "NoLeave": 1, "FixedAllies": 0, "NoOtherSupport": 2, "XpRequirements": "v1", "AllytimeSupport": 0, "PointsMemberCount": 0, "NoOtherSupportType": 1, "WarsAutoacceptDays": 7, "WarsMemberRequirement": 5, "WarsPointsRequirement": 15000}, "Game": {"Tech": 2, "Event": 31, "Hauls": 1, "Archer": 1, "Church": 0, "Knight": 3, "HaulsMax": 100000, "FakeLimit": 1, "FarmLimit": 0, "HaulsBase": 1000, "Scavenging": 0, "Stronghold": 0, "Watchtower": 1, "BarbarianRise": 0.003, "BaseProduction": 30, "KnightNewItems": 0, "SuppressEvents": 0, "BarbarianShrink": 1, "BuildtimeFormula": 2, "BarbarianMaxPoints": 1000}, "Misc": {"Tutorial": 5, "KillRanking": 2, "TradeCancelTime": 300}, "Snob": {"Gold": 1, "Rise": 2, "Factor": 0.5, "MaxDist": 50, "CoinIron": 25000, "CoinWood": 28000, "CoinStone": 30000, "CheapRebuild": 0, "NoBarbConquer": 0}, "Build": {"Destroy": 1}, "Coord": {"Func": 4, "Inner": 1421, "MapSize": 1000, "BonusNew": 0, "SelectStart": 1, "NobleRestart": 0, "BonusVillages": 20, "EmptyVillages": 100, "StartVillages": 1, "VillageMoveWait": -1}, "Moral": 1, "Night": {"Active": 1, "EndHour": 7, "Duration": 14, "DefFactor": 3, "StartHour": 23}, "Sleep": {"Max": 10, "Min": 6, "Delay": 60, "Active": 0, "MaxAwake": 36, "MinAwake": 12, "WarnTime": 10}, "Speed": 1.6, "Newbie": {"Days": 5, "Ratio": 20, "RatioDays": 30, "RemoveNewbieVillages": 1}, "Sitter": {"Allow": 1}, "Commands": {"MillisArrival": 1, "CommandCancelTime": 600}, "Buildings": {"CustomFarm": -1, "CustomHide": -1, "CustomIron": -1, "CustomMain": -1, "CustomSnob": -1, "CustomWall": -1, "CustomWood": -1, "CustomPlace": -1, "CustomSmith": -1, "CustomStone": -1, "CustomChurch": -1, "CustomGarage": -1, "CustomMarket": -1, "CustomStable": -1, "CustomStatue": -1, "CustomStorage": -1, "CustomBarracks": -1, "CustomWatchtower": -1}, "UnitSpeed": 0.65}', '{"Farm": {"Pop": 0, "Iron": 30, "Wood": 45, "Stone": 40, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 750, "PopFactor": 1, "IronFactor": 1.29, "WoodFactor": 1.3, "StoneFactor": 1.32, "BuildTimeFactor": 1.2}, "Hide": {"Pop": 2, "Iron": 50, "Wood": 50, "Stone": 60, "MaxLevel": 10, "MinLevel": 0, "BuildTime": 1125, "PopFactor": 1.17, "IronFactor": 1.25, "WoodFactor": 1.25, "StoneFactor": 1.25, "BuildTimeFactor": 1.2}, "Iron": {"Pop": 10, "Iron": 70, "Wood": 75, "Stone": 65, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 675, "PopFactor": 1.17, "IronFactor": 1.24, "WoodFactor": 1.252, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Main": {"Pop": 5, "Iron": 70, "Wood": 90, "Stone": 80, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 562.5, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Snob": {"Pop": 80, "Iron": 10000, "Wood": 15000, "Stone": 25000, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 366750, "PopFactor": 1.17, "IronFactor": 2, "WoodFactor": 2, "StoneFactor": 2, "BuildTimeFactor": 1.2}, "Wall": {"Pop": 5, "Iron": 20, "Wood": 50, "Stone": 100, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 2250, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Wood": {"Pop": 5, "Iron": 40, "Wood": 50, "Stone": 60, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 562.5, "PopFactor": 1.155, "IronFactor": 1.245, "WoodFactor": 1.25, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Place": {"Pop": 0, "Iron": 30, "Wood": 10, "Stone": 40, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 6787.5, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Smith": {"Pop": 20, "Iron": 240, "Wood": 220, "Stone": 180, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 3750, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stone": {"Pop": 10, "Iron": 40, "Wood": 65, "Stone": 50, "MaxLevel": 30, "MinLevel": 0, "BuildTime": 562.5, "PopFactor": 1.14, "IronFactor": 1.24, "WoodFactor": 1.27, "StoneFactor": 1.265, "BuildTimeFactor": 1.2}, "Garage": {"Pop": 8, "Iron": 260, "Wood": 300, "Stone": 240, "MaxLevel": 15, "MinLevel": 0, "BuildTime": 3750, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Market": {"Pop": 20, "Iron": 100, "Wood": 100, "Stone": 100, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 1687.5, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Stable": {"Pop": 8, "Iron": 260, "Wood": 270, "Stone": 240, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 3750, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Statue": {"Pop": 10, "Iron": 220, "Wood": 220, "Stone": 220, "MaxLevel": 1, "MinLevel": 0, "BuildTime": 937.5, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.275, "BuildTimeFactor": 1.2}, "Storage": {"Pop": 0, "Iron": 40, "Wood": 60, "Stone": 50, "MaxLevel": 30, "MinLevel": 1, "BuildTime": 637.5, "PopFactor": 1.15, "IronFactor": 1.245, "WoodFactor": 1.265, "StoneFactor": 1.27, "BuildTimeFactor": 1.2}, "Barracks": {"Pop": 7, "Iron": 90, "Wood": 200, "Stone": 170, "MaxLevel": 25, "MinLevel": 0, "BuildTime": 1125, "PopFactor": 1.17, "IronFactor": 1.26, "WoodFactor": 1.26, "StoneFactor": 1.28, "BuildTimeFactor": 1.2}, "Watchtower": {"Pop": 500, "Iron": 10000, "Wood": 12000, "Stone": 14000, "MaxLevel": 20, "MinLevel": 0, "BuildTime": 8250, "PopFactor": 1.18, "IronFactor": 1.18, "WoodFactor": 1.17, "StoneFactor": 1.17, "BuildTimeFactor": 1.2}}', '{"Axe": {"Pop": 1, "Carry": 10, "Speed": 17.307692307692, "Attack": 40, "Defense": 10, "BuildTime": 825, "DefenseArcher": 10, "DefenseCavalry": 5}, "Ram": {"Pop": 5, "Carry": 0, "Speed": 28.846153846154, "Attack": 2, "Defense": 20, "BuildTime": 3000, "DefenseArcher": 20, "DefenseCavalry": 50}, "Spy": {"Pop": 2, "Carry": 0, "Speed": 8.6538461538462, "Attack": 0, "Defense": 2, "BuildTime": 562.5, "DefenseArcher": 2, "DefenseCavalry": 1}, "Snob": {"Pop": 100, "Carry": 0, "Speed": 33.653846153846, "Attack": 30, "Defense": 100, "BuildTime": 11250, "DefenseArcher": 100, "DefenseCavalry": 50}, "Heavy": {"Pop": 6, "Carry": 50, "Speed": 10.576923076923, "Attack": 150, "Defense": 200, "BuildTime": 2250, "DefenseArcher": 180, "DefenseCavalry": 80}, "Light": {"Pop": 4, "Carry": 80, "Speed": 9.6153846153846, "Attack": 130, "Defense": 30, "BuildTime": 1125, "DefenseArcher": 30, "DefenseCavalry": 40}, "Spear": {"Pop": 1, "Carry": 25, "Speed": 17.307692307692, "Attack": 10, "Defense": 15, "BuildTime": 637.5, "DefenseArcher": 20, "DefenseCavalry": 45}, "Sword": {"Pop": 1, "Carry": 15, "Speed": 21.153846153846, "Attack": 25, "Defense": 50, "BuildTime": 937.5, "DefenseArcher": 40, "DefenseCavalry": 15}, "Archer": {"Pop": 1, "Carry": 10, "Speed": 17.307692307692, "Attack": 15, "Defense": 50, "BuildTime": 1125, "DefenseArcher": 5, "DefenseCavalry": 40}, "Knight": {"Pop": 10, "Carry": 100, "Speed": 9.6153846153846, "Attack": 150, "Defense": 250, "BuildTime": 13500, "DefenseArcher": 150, "DefenseCavalry": 400}, "Marcher": {"Pop": 5, "Carry": 50, "Speed": 9.6153846153846, "Attack": 120, "Defense": 40, "BuildTime": 1687.5, "DefenseArcher": 50, "DefenseCavalry": 30}, "Militia": {"Pop": 0, "Carry": 0, "Speed": 0.016666666666667, "Attack": 0, "Defense": 15, "BuildTime": 1, "DefenseArcher": 25, "DefenseCavalry": 45}, "Catapult": {"Pop": 8, "Carry": 0, "Speed": 28.846153846154, "Attack": 100, "Defense": 100, "BuildTime": 4500, "DefenseArcher": 100, "DefenseCavalry": 50}}', '2023-01-05 10:00:06.486598 +00:00', '2023-08-07 09:01:44.409623 +00:00', '2023-08-07 09:00:35.290524 +00:00', '2023-08-07 09:03:15.761983 +00:00', 'uk', '2023-08-06 23:30:13.801148 +00:00', '2023-08-06 23:30:03.325053 +00:00', '2023-08-07 10:00:08.681000 +00:00', 9146, 49, 860);
-- +goose StatementEnd

-- +goose Down
-- +goose StatementBegin
-- +goose StatementEnd
